%% cfs1 and cfs2 algo objects configuration

obj1=algoobj_cfs1; obj1.init; obj1.setup;
obj2=algoobj_cfs2; obj2.init; obj2.setup;

%% test shot actualization
shot=-1;
obj1.actualize(shot);
obj2.actualize(shot);

%% Workaround to define proc buses in one place only
% NOTE: this is not to be replicated,
% an higher hyerarchical SCDDS level must be put in place
% to do it properly
dd1=Simulink.data.dictionary.open('algo_cfs1.sldd');
ddd1=dd1.getSection('Design Data');
ddd1.deleteEntry('algo_cfs2_procout');
% 
dd2=Simulink.data.dictionary.open('algo_cfs2.sldd');
ddd2=dd2.getSection('Design Data');
ddd2.deleteEntry('algo_cfs1_procout');
% 
dd1.addDataSource('algo_cfs2.sldd');
dd2.addDataSource('algo_cfs1.sldd');

%% Simulink simulation
sim('cfs12combined_test');

%% cfs1 and cfs2 build
SCDconf_setConf('configurationSettingsCODEgcc');
load_system('algo_cfs1');
rtwbuild('algo_cfs1');

load_system('algo_cfs2');
rtwbuild('algo_cfs2');

%% MARTe2 cfg file autogeneration
cd marte2cfg/2threads/
algo_cfs1and2_create_marte2_cfg;
cd ../..

%% Trasferring gencode and cfg to the realtime machine
system('scp marte2cfg/2threads/algo_cfs1and2_2threads.cfg root@node06:/root/MARTe2-examples/Configurations');
system('scp ../../../gencodes/CodeGenFolder/algo_cfs1.so  root@node06:/root/MARTe2-examples/Simulinkso');
system('scp ../../../gencodes/CodeGenFolder/algo_cfs2.so  root@node06:/root/MARTe2-examples/Simulinkso');

%% MARTe2 run of the same thing
% Here we assume .cfg and .so for 
% cfs1 and cfs2 algos have been already generated
% ans transferred to realtime test machine
system('ssh root@node06 ''source /etc/profile; cd MARTe2-examples; ./runcfs.sh''');

%% Getting MARTe2 outputs
mdsconnect('scd');
op=mdsopen('scdds',0)

cfs1signal3marte2=tdi('cfs1.outputs.signal3');
cfs2signal3marte2=tdi('cfs2.outputs.signal3');

%% Plot combined simulation / realtime exec signals
figure(1);
clf
hold on
plot(cfs1simout.signal3,'k--');%'LineWidth',4);
plot(cfs2simout.signal3,'k--');%'LineWidth',4);
plot(cfs1signal3marte2,'r');
plot(cfs2signal3marte2,'r');
xlim([0 3]);
grid on




